#include "MenuObject.h"

MenuObject::MenuObject()
{
	x=0;y=0;		
	sound = NULL;
}


MenuObject::MenuObject (int x1, int y1)
{
	x = x1; y = y1;	
	sound = NULL;
}


MenuObject::MenuObject(int x1, int y1,char* Filename1,char* Filename2)
{
	x = x1;
	y = y1;	
	sound = NULL;
	loadImageNormal(Filename1);
	loadImageHighlighted(Filename2);
}

MenuObject::MenuObject(int x1, int y1,char* Filename1,char* Filename2, SoundObject* loadSound)
{
	x = x1;
	y = y1;		
	sound = loadSound;
	loadImageNormal(Filename1);
	loadImageHighlighted(Filename2);
}

void MenuObject::loadImageNormal (char* Filename)
{
	normal.load(Filename);
}

void MenuObject::loadImageHighlighted (char* Filename)
{
	highlight.load(Filename);
}

void MenuObject::setSound(SoundObject* loadSound)
{
	sound = loadSound;
}

void MenuObject::loadSelectionSound (SoundObject* loadSound)
{
	sound = loadSound;
}


void MenuObject::displayNormal()
{    
	normal.display(x,y+getSizeY());
}

void MenuObject::displayHighlighted()
{		
	highlight.display(x,y+getSizeY());
}

void MenuObject::setTransparencyValue()
{
	normal.calculateAlphaValue();
	highlight.calculateAlphaValue();
}

void MenuObject::setTransparencyLightness()
{
	normal.calculateAlphaLightness();
	highlight.calculateAlphaLightness();
}
